function varargout = GklsGUI(varargin)
% GKLSGUI M-file for GklsGUI.fig

% Last Modified by GUIDE v2.5 15-Nov-2009 17:56:31

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @GklsGUI_OpeningFcn, ...
                   'gui_OutputFcn',  @GklsGUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before GklsGUI is made visible.
function GklsGUI_OpeningFcn(hObject, eventdata, handles, varargin)

% Choose default command line output for GklsGUI
handles.output = hObject;

populateMultiMenu(handles);


problems=dir(fullfile('.','*@*Problem'));
for i=1:length(problems)
    problems(i).name=problems(i).name([2:(length(problems(i).name)-7)]);
end
set(handles.problemsPopup,'String',char({problems.name}));
set(handles.problemsPopup,'Value',5.0);
func=cellstr(get(handles.methodsPopup,'String'));
selected=func{1};  
populateUniMenu(handles, selected);
handles.drawType=1;
handles.drawAspect=1;
clearOutput(handles);
problemsPopup_Callback(hObject, eventdata, handles)
% Update handles structure
guidata(hObject, handles);

function populateMultiMenu(handles)
funcs=dir(fullfile('multidimAlg','*.m'));
i=1;
r=1;
list={};
while (i<=length(funcs))
       list(r) = {funcs(i).name};
       r=r+1;
       i=i+1;
end
set(handles.methodsPopup,'String',list);

function populateUniMenu(handles, multiMethod)
uniFuncs=dir(fullfile('unidimAlg','*.m'));
i=1;
r=1;
list={};
gm = isGAvailable(multiMethod);
hm = isHAvailable(multiMethod);
ls = isLSAvailable(multiMethod);

if (ls)
    while (i<=length(uniFuncs))
        name = uniFuncs(i).name;
        gu = isGAvailable(name);
        hu = isHAvailable(name);
        if (~((gu&&~gm)||(hu&&~hm)))
            list(r) = {name};
            r=r+1;
        end
        i=i+1;
    end
end
set(handles.uniMethodsPopup,'String',list);


% --- Outputs from this function are returned to the command line.
function varargout = GklsGUI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on slider movement.
function slider1_Callback(hObject, eventdata, handles)

set(handles.slider1,'TooltipString',strcat('Value:  ',num2str(get(handles.slider1,'Value'),2)));
slider2_Callback(hObject, eventdata, handles);


% --- Executes during object creation, after setting all properties.
function slider1_CreateFcn(hObject, eventdata, handles)

if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


function editClass_Callback(hObject, eventdata, handles)


% --- Executes during object creation, after setting all properties.
function editClass_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on slider movement.
function slider2_Callback(hObject, eventdata, handles)

distance=get(handles.slider1,'Value');
set(handles.slider2,'TooltipString',strcat('Value: ',num2str(distance*get(handles.slider2,'Value')/2,2)));


% --- Executes during object creation, after setting all properties.
function slider2_CreateFcn(hObject, eventdata, handles)

if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


function editMinima_Callback(hObject, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function editMinima_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in methodsPopup.
function methodsPopup_Callback(hObject, eventdata, handles)
funcN=get(handles.methodsPopup,'Value');
func=cellstr(get(handles.methodsPopup,'String'));
selected=func{funcN};
populateUniMenu(handles, selected);
if (isLSAvailable(selected))
    set(handles.uniMethodsPopup,'Enable','on');
else
    set(handles.uniMethodsPopup,'Enable','off');
end

% --- Executes during object creation, after setting all properties.
function methodsPopup_CreateFcn(hObject, eventdata, handles)

%if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
%    set(hObject,'BackgroundColor','white');
%end



function editStartX_Callback(hObject, eventdata, handles)



% --- Executes during object creation, after setting all properties.
function editStartX_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editStartY_Callback(hObject, eventdata, handles)



% --- Executes during object creation, after setting all properties.
function editStartY_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in initialPointButton.
function initialPointButton_Callback(hObject, eventdata, handles)


if 1==get(hObject,'Value')
    disableAll(handles);
    set(handles.initialPointButton,'Enable','on');
    datacursormode on;
else
    datacursormode off;
    dc=datacursormode(gcf);
    is=getCursorInfo(dc);
    set(handles.editStartX,'String',round(is.Position(1)*10^3)/10^3);
    set(handles.editStartY,'String',round(is.Position(2)*10^3)/10^3);
    enableAll(handles);
end

% --- Executes on button press in startButton.
function startButton_Callback(hObject, eventdata, handles)
x=eval(get(handles.editStartX,'String'));
y=eval(get(handles.editStartY,'String'));
reset(handles.problem);
setTol(handles.problem,eval(get(handles.editTol,'String')));
setMaxiter(handles.problem,eval(get(handles.editMaxiter,'String')));
setEpsilonArmijo(handles.problem,eval(get(handles.editEpsilon,'String')));
setEtaArmijo(handles.problem,eval(get(handles.editEta,'String')));
getMaxiter(handles.problem);
nextPoint(handles.problem,[x y]);

% Creo la stringa della funzione e la eseguo
funcN=get(handles.methodsPopup,'Value');
func=cellstr(get(handles.methodsPopup,'String'));
func=func{funcN};
func=func([1:length(func)-2]);
uniFuncN=get(handles.uniMethodsPopup,'Value');
uniFunc=cellstr(get(handles.uniMethodsPopup,'String'));
uniFunc=uniFunc{uniFuncN};
% il seguente warning è infondato.. TODO supppress it
uniFunc=uniFunc([1:length(uniFunc)-2]);
cmd = strcat(func,'(handles.problem,uniFunc);');
eval(cmd);

[x1,x2,x3]=getPath(handles.problem);
n=length(handles.solutions);
handles.solutions{n+1}={x1,x2,x3};

% Cerco il punto di minimo piu' vicino alla soluzione trovata
solSteps=length(x1);
minFound=[x1(solSteps) x2(solSteps)];
minPoints=handles.minInfo(:,[2 3]);
[m,n]=size(minPoints);
temp=[ones(m,1)*minFound(1) ones(m,1)*minFound(2)];
distance=temp-minPoints;
distanceNormQuad=distance(:,1).^2+distance(:,2).^2;
[a,index]=min(distanceNormQuad);

% TODO cercare un modo di visualizzare sta roba!!!!!
distanza=sqrt(distanceNormQuad(index));
differenza=abs(x3(solSteps)-handles.minInfo(index,1));
[evals,grads,hesss]=getOpsDone(handles.problem);
println(handles,['Iter.   = ' num2str(solSteps)]);
println(handles,['Evals   = F:' num2str(evals) ...
                          ' G:' num2str(grads) ...
                          ' H:' num2str(hesss) ]);
println(handles,['x_n-x*  = ' num2str(distanza)]);
println(handles,['f_n-f*  = ' num2str(differenza)]);
println(handles,' ');


guidata(hObject, handles);
draw(hObject, handles);

% --- Executes on button press in rotateButton.
function rotateButton_Callback(hObject, eventdata, handles)

axes(handles.plotAxes);
rotate3d

function draw(hObject, handles)
handles.lastDrawn=hObject;
axes(handles.plotAxes);
zoom=str2double(get(handles.distanceEdit,'String'));
centreX=str2double(get(handles.editCentreX,'String'));
centreY=str2double(get(handles.editCentreY,'String'));
[a,b]=meshgrid(linspace(centreX-zoom,centreX+zoom,70),linspace(centreY-zoom,centreY+zoom,70));
[p,q]=view;
if p~=0 || q~=90
    handles.view=[p,q];
end

switch handles.drawAspect
    case 1
        meshc(a,b,evalMesh(handles.problem,a,b,handles.drawType));
        colormap(cool);
        view(handles.view);
        grid on;
    case 2
        contour(a,b,evalMesh(handles.problem,a,b,handles.drawType),50);
        colormap(jet);
        grid on;
    case 3
        contour3(a,b,evalMesh(handles.problem,a,b,handles.drawType),50);
        colormap(jet);
        view(handles.view);
        grid off;
    case 4
        [a,b]=meshgrid(linspace(-1,1,200));
        surfl(a,b,evalMesh(handles.problem,a,b,handles.drawType));
        shading interp;
        colormap(copper);
        view(handles.view);
        grid on;
end

if handles.drawType == 1
    hold on
    colors={'b','r','k','m','y','c','g'};
    for i=1:length(handles.solutions)
        plot3(handles.solutions{i}{1},handles.solutions{i}{2},handles.solutions{i}{3},'Color',colors{mod(i-1,7)+1},'Marker','.');
    end
    hold off
end
guidata(hObject, handles);

function generate(hObject, handles)
tol=eval(get(handles.editTol,'String'));
maxiter=eval(get(handles.editMaxiter,'String'));
nmin=eval(get(handles.editMinima,'String'));
class=eval(get(handles.editClass,'String'));
distance=get(handles.slider1,'Value');
radius=distance*get(handles.slider2,'Value')/2;
handles.problem=gklsProblem(tol,maxiter,nmin,-1,distance,radius,class);
handles.minInfo=getMinInfo(handles.problem);
guidata(hObject, handles);


% --- Executes on button press in meshButton.
function meshButton_Callback(hObject, eventdata, handles)

handles.drawAspect=1;
guidata(hObject, handles);
draw(hObject, handles);


% --- Executes on button press in contourButton.
function contourButton_Callback(hObject, eventdata, handles)

handles.drawAspect=2;
guidata(hObject, handles);
draw(hObject, handles);


% --- Executes on button press in contour3DButton.
function contour3DButton_Callback(hObject, eventdata, handles)

handles.drawAspect=3;
guidata(hObject, handles);
draw(hObject, handles);

% --- Executes on button press in surfButton.
function surfButton_Callback(hObject, eventdata, handles)

handles.drawAspect=4;
guidata(hObject, handles);
draw(hObject, handles);


% --- Executes on button press in drawFunButt.
function drawFunButt_Callback(hObject, eventdata, handles)

handles.drawType=1;
guidata(hObject, handles);
draw(hObject, handles);


% --- Executes on button press in drawDxButt.
function drawDxButt_Callback(hObject, eventdata, handles)

handles.drawType=21;
guidata(hObject, handles);
draw(hObject, handles);


% --- Executes on button press in drawDyButt.
function drawDyButt_Callback(hObject, eventdata, handles)

handles.drawType=22;
guidata(hObject, handles);
draw(hObject, handles);


% --- Executes on button press in drawDxxButt.
function drawDxxButt_Callback(hObject, eventdata, handles)

handles.drawType=31;
guidata(hObject, handles);
draw(hObject, handles);


% --- Executes on button press in drawDxyButt.
function drawDxyButt_Callback(hObject, eventdata, handles)

handles.drawType=32;
guidata(hObject, handles);
draw(hObject, handles);


% --- Executes on button press in drawDyyButt.
function drawDyyButt_Callback(hObject, eventdata, handles)

handles.drawType=33;
guidata(hObject, handles);
draw(hObject, handles);



function outputEdit_Callback(hObject, eventdata, handles)


% --- Executes during object creation, after setting all properties.
function outputEdit_CreateFcn(hObject, eventdata, handles)

%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function println(handles, string)
old=get(handles.outputEdit,'String');
set(handles.outputEdit,'String',strvcat(old,string));
[m,n]=size(old);
set(handles.outputEdit,'ListboxTop',m);

function clearOutput(handles)
set(handles.outputEdit,'String',strvcat('          -= GklsGUI v 0.2 =-',' '));

function enableAll(handles)
set(handles.rotateButton,'Enable','on');
set(handles.initialPointButton,'Enable','on');
set(handles.generateProblemsButton,'Enable','on');
set(handles.menuPlot,'Enable','on');
set(handles.initialPointButton,'Enable','on');
set(handles.rotateButton,'Enable','on');
set(handles.startButton,'Enable','on');
set(handles.statsButton,'Enable','on');
set(handles.menuStyle,'Enable','on');

function disableAll(handles)
set(handles.rotateButton,'Enable','off');
set(handles.initialPointButton,'Enable','off');
set(handles.generateProblemsButton,'Enable','off');
set(handles.menuPlot,'Enable','off');
set(handles.initialPointButton,'Enable','off');
set(handles.rotateButton,'Enable','off');
set(handles.startButton,'Enable','off');
set(handles.statsButton,'Enable','off');
set(handles.menuStyle,'Enable','off');


function editTol_Callback(hObject, eventdata, handles)
% hObject    handle to editTol (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editTol as text
%        str2double(get(hObject,'String')) returns contents of editTol as a double


% --- Executes during object creation, after setting all properties.
function editTol_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editTol (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in genBananaButton.
function generateProblemsButton_Callback(hObject, eventdata, handles)
% hObject    handle to genBananaButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% il seguente warning è infondato.. TODO supppress it
tol=eval(get(handles.editTol,'String'));
maxiter=eval(get(handles.editMaxiter,'String'));

problemN=get(handles.problemsPopup,'Value');
problem=cellstr(get(handles.problemsPopup,'String'));
problem=problem{problemN};

problem=strcat(problem,'Problem');
if length(strfind(problem,'gkls'))>0
    nmin=eval(get(handles.editMinima,'String'));
    class=eval(get(handles.editClass,'String'));
    distance=get(handles.slider1,'Value');
    radius=distance*get(handles.slider2,'Value')/2;
    cmd = strcat(problem,'(tol,maxiter,nmin,-1,distance,radius,class)');
else
    cmd = strcat(problem,'(tol,maxiter);');    
end

handles.problem=eval(cmd);

handles.minInfo=getMinInfo(handles.problem);

enableAll(handles);
handles.solutions={};
handles.view=view(3);

guidata(hObject, handles);
draw(hObject, handles);
clearOutput(handles);


function editMaxiter_Callback(hObject, eventdata, handles)
% hObject    handle to editMaxiter (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editMaxiter as text
%        str2double(get(hObject,'String')) returns contents of editMaxiter as a double


% --- Executes during object creation, after setting all properties.
function editMaxiter_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editMaxiter (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in uniMethodsPopup.
function uniMethodsPopup_Callback(hObject, eventdata, handles)
% hObject    handle to uniMethodsPopup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns uniMethodsPopup contents as cell array
%        contents{get(hObject,'Value')} returns selected item from uniMethodsPopup

uniFuncN=get(handles.uniMethodsPopup,'Value');
uniFunc=cellstr(get(handles.uniMethodsPopup,'String'));
selected=uniFunc{uniFuncN};
if (length(strfind(selected,'armijo'))>0 || length(strfind(selected,'goldstein'))>0 || length(strfind(selected,'wolfe'))>0)
    set(handles.editEpsilon,'Enable','on');
    set(handles.editEta,'Enable','on');
else
    set(handles.editEpsilon,'Enable','off');
    set(handles.editEta,'Enable','off');
end

% --- Executes during object creation, after setting all properties.
function uniMethodsPopup_CreateFcn(hObject, eventdata, handles)
% hObject    handle to uniMethodsPopup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in problemsPopup.
function problemsPopup_Callback(hObject, eventdata, handles)
% hObject    handle to problemsPopup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns problemsPopup contents as cell array
%        contents{get(hObject,'Value')} returns selected item from problemsPopup
problemN=get(handles.problemsPopup,'Value');
problem=cellstr(get(handles.problemsPopup,'String'));
problem=problem{problemN};

if length(strfind(problem,'gkls'))>0
    enableGklsPanel(handles,'on');    
else
    enableGklsPanel(handles,'off');
end

function enableGklsPanel(handles,enable)
set(handles.editMinima,'Enable',enable);
set(handles.slider1,'Enable',enable);
set(handles.slider2,'Enable',enable);
set(handles.editClass,'Enable',enable);


% --- Executes during object creation, after setting all properties.
function problemsPopup_CreateFcn(hObject, eventdata, handles)
% hObject    handle to problemsPopup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in generateProblemsButton.
function pushbutton20_Callback(hObject, eventdata, handles)
% hObject    handle to generateProblemsButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)



function edit8_Callback(hObject, eventdata, handles)
% hObject    handle to editMinima (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editMinima as text
%        str2double(get(hObject,'String')) returns contents of editMinima as a double


% --- Executes during object creation, after setting all properties.
function edit8_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editMinima (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on slider movement.
function slider3_Callback(hObject, eventdata, handles)
% hObject    handle to slider1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function slider3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function slider4_Callback(hObject, eventdata, handles)
% hObject    handle to slider2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function slider4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end



function edit9_Callback(hObject, eventdata, handles)
% hObject    handle to editClass (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editClass as text
%        str2double(get(hObject,'String')) returns contents of editClass as a double


% --- Executes during object creation, after setting all properties.
function edit9_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editClass (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on slider movement.
function sliderZoom_Callback(hObject, eventdata, handles)
% hObject    handle to sliderZoom (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

zoom=get(handles.sliderZoom,'Value');
set(handles.distanceEdit,'String',-zoom);
maxZoom=get(handles.sliderZoom,'Max');
minZoom=get(handles.sliderZoom,'Min');
if(maxZoom==zoom)
    maxZoom=zoom*0.5;
    minZoom=maxZoom*10;
    set(handles.sliderZoom,'Max',maxZoom);
    set(handles.sliderZoom,'Min',minZoom);
end
if(minZoom==zoom)
    minZoom=zoom*2;
    maxZoom=minZoom/10;
    set(handles.sliderZoom,'Min',minZoom);
    set(handles.sliderZoom,'Max',maxZoom);
end

set(handles.sliderZoom,'TooltipString',strcat('Value:  ',num2str(-zoom,2)));
draw(handles.lastDrawn,handles);
% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function sliderZoom_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sliderZoom (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end



function editCentreX_Callback(hObject, eventdata, handles)
% hObject    handle to editCentreX (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

draw(handles.lastDrawn,handles);
% Hints: get(hObject,'String') returns contents of editCentreX as text
%        str2double(get(hObject,'String')) returns contents of editCentreX as a double


% --- Executes during object creation, after setting all properties.
function editCentreX_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editCentreX (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editCentreY_Callback(hObject, eventdata, handles)
% hObject    handle to editCentreY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
draw(handles.lastDrawn,handles);
% Hints: get(hObject,'String') returns contents of editCentreY as text
%        str2double(get(hObject,'String')) returns contents of editCentreY as a double


% --- Executes during object creation, after setting all properties.
function editCentreY_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editCentreY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editEpsilon_Callback(hObject, eventdata, handles)
% hObject    handle to editEpsilon (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editEpsilon as text
%        str2double(get(hObject,'String')) returns contents of editEpsilon as a double


% --- Executes during object creation, after setting all properties.
function editEpsilon_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editEpsilon (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editEta_Callback(hObject, eventdata, handles)
% hObject    handle to editEta (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editEta as text
%        str2double(get(hObject,'String')) returns contents of editEta as a double


% --- Executes during object creation, after setting all properties.
function editEta_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editEta (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in statsButton.
function statsButton_Callback(hObject, eventdata, handles)
% hObject    handle to statsButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

clearOutput(handles);

% Creo la stringa della funzione e la eseguo
funcN=get(handles.methodsPopup,'Value');
func=cellstr(get(handles.methodsPopup,'String'));
orFunc=func{funcN};
populateUniMenu(handles, orFunc);
func=orFunc([1:length(orFunc)-2]);

uniFuncs=cellstr(get(handles.uniMethodsPopup,'String'));
lsNum=length(uniFuncs);

max_test=eval(get(handles.runsEdit,'String'));
runs=max_test;
%rate=1/max_test;

conv(lsNum)=0;
iter(lsNum)=0;
valF(lsNum)=0;
valG(lsNum)=0;
valH(lsNum)=0;
dist(lsNum)=0;
bottom(lsNum)=0;

zoom=str2double(get(handles.distanceEdit,'String'));

centreX=str2double(get(handles.editCentreX,'String'));
centreY=str2double(get(handles.editCentreY,'String'));
star=false;
while (max_test>0)

    enableDraw=get(handles.drawCheck,'Value');
    
    x=centreX-zoom+rand(1)*zoom*2;
    y=centreY-zoom+rand(1)*zoom*2;
    
    lsNum=1;
    while (lsNum<=length(uniFuncs))        
        uniFunc=uniFuncs{lsNum};        

        % il seguente warning è infondato.. TODO supppress it
        uniFunc=uniFunc([1:length(uniFunc)-2]);


        reset(handles.problem);
        setTol(handles.problem,eval(get(handles.editTol,'String')));
        setMaxiter(handles.problem,eval(get(handles.editMaxiter,'String')));
        setEpsilonArmijo(handles.problem,eval(get(handles.editEpsilon,'String')));
        setEtaArmijo(handles.problem,eval(get(handles.editEta,'String')));
        getMaxiter(handles.problem);

        nextPoint(handles.problem,[x y]);

        cmd = strcat(func,'(handles.problem,uniFunc);');
        eval(cmd);

        [x1,x2,x3]=getPath(handles.problem);
        n=length(handles.solutions);
        handles.solutions{n+1}={x1,x2,x3};

        % Cerco il punto di minimo piu' vicino alla soluzione trovata
        solSteps=length(x1);
        minFound=[x1(solSteps) x2(solSteps)];
        minPoints=handles.minInfo(:,[2 3]);
        [m,n]=size(minPoints);
        temp=[ones(m,1)*minFound(1) ones(m,1)*minFound(2)];
        distance=temp-minPoints;
        distanceNormQuad=distance(:,1).^2+distance(:,2).^2;
        [a,index]=min(distanceNormQuad);

        % TODO cercare un modo di visualizzare sta roba!!!!!
        distanza=sqrt(distanceNormQuad(index));
        differenza=abs(x3(solSteps)-handles.minInfo(index,1));
        [evals,grads,hesss]=getOpsDone(handles.problem);
    %     println(handles,['Iter.   = ' num2str(solSteps)]);
    %     println(handles,['Evals   = F:' num2str(evals) ...
    %                               ' G:' num2str(grads) ...
    %                               ' H:' num2str(hesss) ]);
    %     println(handles,['x_n-x*  = ' num2str(distanza)]);
    %     println(handles,['f_n-f*  = ' num2str(differenza)]);
    %     println(handles,' ');

        if (isnan(distanza)||isinf(distanza)||isnan(differenza)||isinf(differenza))
            star=true;
        else  
            conv(lsNum)=conv(lsNum)+1;
            iter(lsNum)=iter(lsNum)+solSteps;
            valF(lsNum)=valF(lsNum)+evals;
            valG(lsNum)=valG(lsNum)+grads;
            valH(lsNum)=valH(lsNum)+hesss;
            dist(lsNum)=dist(lsNum)+distanza;
            bottom(lsNum)=bottom(lsNum)+differenza;
        end
        
        %guidata(hObject, handles);
        if (enableDraw==1)
            draw(hObject, handles);
        end
        lsNum=lsNum+1;
    end
    max_test=max_test-1;
    str = ['Run # ' num2str(runs-max_test) ' (' num2str(((runs-max_test)/runs)*100) '%)' ]
    println(handles, str);
    %guidata(hObject, handles);

end

lsNum=1;
while (lsNum<=length(uniFuncs)) 
    rate = conv(lsNum);
    iter(lsNum)=iter(lsNum)/rate;
    valF(lsNum)=valF(lsNum)/rate;
    valG(lsNum)=valG(lsNum)/rate;
    valH(lsNum)=valH(lsNum)/rate;
    dist(lsNum)=dist(lsNum)/rate;
    bottom(lsNum)=bottom(lsNum)/rate;
    lsNum=lsNum+1;
end

columnHeader = {'Iterations', 'EvalF', 'EvalG', 'EvalH', 'x_n-x*','f_n-f*'};

problemN=get(handles.problemsPopup,'Value');
problem=cellstr(get(handles.problemsPopup,'String'));
problem=problem{problemN};

fn=strcat('statistics_',problem,'-',func,'.csv');
fl=strcat('statistics_',problem,'-',func,'.tex');
delete(fn);
file_1 = fopen(fn,'w');
file_2 = fopen(fl,'w');
fprintf(file_1,'Method,Iter., EvalF, EvalG, EvalH, x_n-x*, f_n-f*\n');
fprintf(file_2,'\\begin{table} [ht]\n');
starText='';
if (star==true)
    starText='. The asterisk at the end of the method name indicates that the method did not converged for some run.';
end
fprintf(file_2,['\\caption{Mean results for problem ',problem, ' (method ',func,'), centered on $x$:',num2str(centreX),' $y$:', num2str(centreY),' distance:',num2str(zoom),' number of runs:',num2str(runs),starText,'}\n']);
fprintf(file_2,strcat('\\centering\n\\begin{tabular}{c c c c c c c}\n'));
fprintf(file_2,strcat('\\hline\\hline\n'));
fprintf(file_2,'Method & Iterations & EvalF & EvalG & EvalH & $x_n-x^*$ & $f_n-f^*$ \\\\\n');
fprintf(file_2,strcat('\\hline\n'));
lsNum=1;
while (lsNum<=length(uniFuncs))    
    uniFunc=uniFuncs{lsNum};
    % il seguente warning è infondastatsButtto.. TODO supppress it
    uniFunc=uniFunc([1:length(uniFunc)-2]);
    row{1}=uniFunc;
    if (conv(lsNum)<runs)
        row{1}=[uniFunc '*'];
    end
    
    println(handles,['LS      = ' row{1} ]);
    println(handles,['Iter.   = ' num2str(iter(lsNum)) ]);
    row{2}=strcat(num2str(iter(lsNum)));
    println(handles,['Evals   = F:' num2str(valF(lsNum)) ...        
                              ' G:' num2str(valG(lsNum)) ...
                              ' H:' num2str(valH(lsNum)) ]);
    row{3}=strcat(num2str(valF(lsNum)));
    row{4}=strcat(num2str(valG(lsNum)));
    row{5}=strcat(num2str(valH(lsNum)));
    println(handles,['x_n-x*  = ' num2str(dist(lsNum),'%0.5g') ]);
    row{6}=strcat(num2str(dist(lsNum),'%0.5g'));
    println(handles,['f_n-f*  = ' num2str(bottom(lsNum),'%0.5g') ]);
    row{7}=strcat(num2str(bottom(lsNum),'%0.5g'));
    println(handles,' ');    
    lsNum=lsNum+1;
    mname=strrep(row{1},'_','-');
    fprintf(file_1,strcat(mname,',',row{2},',',row{3},',',row{4},',',row{5},',',row{6},',',row{7},'\n'));   
    fprintf(file_2,[mname,' & ',row{2},' & ',row{3},' & ',row{4},' & ',row{5},' & ',row{6},' & ',row{7},'\\\\\n']);
end

fprintf(file_1,'\n');    
fprintf(file_1,'\n');    

fprintf(file_1,strcat('Problem: ', problem,' Centered on X: ',num2str(centreX), ' Y: ',num2str(centreY),' Distance: ',num2str(zoom),starText,'\n'));    
fprintf(file_1,strcat('Method: ', func,' Number of runs: ',num2str(runs),'\n'));    

fclose(file_1);

fprintf(file_2,strcat('\\end{tabular}\n'));
fprintf(file_2,strcat('\\label{table:',problem,'}\n'));
fprintf(file_2,strcat('\\end{table}\n'));
fclose(file_2);
    


% --------------------------------------------------------------------
function Untitled_1_Callback(hObject, eventdata, handles)
% hObject    handle to Untitled_1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on selection change in menuPlot.
function menuPlot_Callback(hObject, eventdata, handles)
% hObject    handle to menuPlot (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns menuPlot contents as cell array
%        contents{get(hObject,'Value')} returns selected item from menuPlot

type=get(hObject,'Value');

if (type==1)
    handles.drawType=1;
elseif (type==2)   
    handles.drawType=21;
elseif (type==3)
    handles.drawType=22;
elseif (type==4)
    handles.drawType=31;
elseif (type==5)
	handles.drawType=33;
elseif (type==6)
	handles.drawType=32;
end 
    
guidata(hObject, handles);
draw(hObject, handles);



% --- Executes during object creation, after setting all properties.
function menuPlot_CreateFcn(hObject, eventdata, handles)
% hObject    handle to menuPlot (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in menuStyle.
function menuStyle_Callback(hObject, eventdata, handles)
% hObject    handle to menuStyle (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns menuStyle contents as cell array
%        contents{get(hObject,'Value')} returns selected item from menuStyle

type=get(hObject,'Value');

handles.drawAspect=type;
    
guidata(hObject, handles);
draw(hObject, handles);



% --- Executes during object creation, after setting all properties.
function menuStyle_CreateFcn(hObject, eventdata, handles)
% hObject    handle to menuStyle (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function runsEdit_Callback(hObject, eventdata, handles)
% hObject    handle to runsEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of runsEdit as text
%        str2double(get(hObject,'String')) returns contents of runsEdit as a double


% --- Executes during object creation, after setting all properties.
function runsEdit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to runsEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in drawCheck.
function drawCheck_Callback(hObject, eventdata, handles)
% hObject    handle to drawCheck (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of drawCheck



function distanceEdit_Callback(hObject, eventdata, handles)
% hObject    handle to distanceEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of distanceEdit as text
%        str2double(get(hObject,'String')) returns contents of distanceEdit as a double

zoom=str2double(get(handles.distanceEdit,'String'));
maxZoom=get(handles.sliderZoom,'Max');
minZoom=get(handles.sliderZoom,'Min');
if(maxZoom==zoom)
    maxZoom=zoom*0.5;
    minZoom=maxZoom*10;
    set(handles.sliderZoom,'Max',maxZoom);
    set(handles.sliderZoom,'Min',minZoom);
end
if(minZoom==zoom)
    minZoom=zoom*2;
    maxZoom=minZoom/10;
    set(handles.sliderZoom,'Min',minZoom);
    set(handles.sliderZoom,'Max',maxZoom);
end

draw(handles.lastDrawn,handles);

% --- Executes during object creation, after setting all properties.
function distanceEdit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to distanceEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function avail = isGAvailable(method)
method=method([1:length(method)-2]);
    % these methods use gradient information
a = double(strcmp(method,{'DFP' 'DFPScaling' 'LevMarq' 'NewtonDamped' 'Newton' 'SteepestDescent' 'TrustRegCauchy' 'TrustRegDogleg' 'cubicfitTPP_armijo' 'cubicfitTPP_goldstein' 'cubicfitTPP_tolAlpha' 'cubicfitTPP_tolG' 'cubicfitTPP_wolfe' 'newton' 'newtonTPP_armijo' 'newtonTPP_goldstein' 'newtonTPP_tolAlpha' 'newtonTPP_tolG' 'newtonTPP_wolfe' 'quadfitTPP_armijo' 'quadfitTPP_tolG' 'quadfitTPP_wolfe' 'secant' 'secantTPP_armijo' 'secantTPP_goldstein' 'secantTPP_tolAlpha' 'secantTPP_tolG' 'secantTPP_wolfe' 'wolfe' }));
res = a*a';
if (res>0)
    avail = true;
else
    avail = false;
end


function avail = isHAvailable(method)
method=method([1:length(method)-2]);
    % these methods use hessian information
a = double(strcmp(method,{'LevMarq' 'Newton' 'NewtonDamped' 'TrustRegCauchy' 'TrustRegDogleg' 'newton' 'newtonTPP_armijo' 'newtonTPP_goldstein' 'newtonTPP_tolAlpha' 'newtonTPP_tolG' 'newtonTPP_wolfe'  }));
res = a*a';
if (res>0)
    avail = true;
else
    avail = false;
end


function avail = isLSAvailable(method)
method=method([1:length(method)-2]);
    % these methods use line search techniques
a = double(strcmp(method,{'DFP' 'LevMarq' 'Newton' 'DFPScaling' 'NewtonDamped' 'SteepestDescent' }));
res = a*a';
if (res>0)
    avail = true;
else
    avail = false;
end










