function [A] = lu_fact (A)
%[A] lu_fact = (A)
%Restituisce una matrice A che contiene i valori significativi
%delle due matrici L e U risultato della fattorizzazione di A

n = issquare(A);

if n < 1
    error('la matrice A non e quadrata')
end

for i = 1:n-1
    if A(i,i) ~= 0
        %metto nella i-esima colonna, dall' i+1-esima riga in poi , il vettore elementare di Gauss
        %relativo all' elemento A(i,i)
        A(i+1:n, i) = A(i+1:n, i) / A(i,i);
        A(i+1:n, i+1:n) = A(i+1:n, i+1:n) - A(i+1:n, i) * A(i, i+1:n);
    else
        error('la matrice in input non ha tutti i minori principali diversi da zero, prova con la funzione lup_fact');
    end
end
