function [A, p] = lupp_fact(A)
%
%

n = issquare(A);

if n < 1
    error('la matrice A non e quadrata')
end

p=1:n;

for i=1:n-1
    %calcola lelemento massimo in valore assoluto
    %della colonna
    [m,k]=max(abs(A(i:n,i)));
    k=k+i-1;
    %aggiorna lindice rispetto ad A
    if(m==0)
        error('La matrice deve essere nonsingolare');
    end
    if(k>i)
        %scambia le righe di A
        A([i;k],:)=A([k;i],:);
        %aggiorna il vettore di permutazione
        p([i,k])=p([k,i]);
    end
    %esegue i due passi di LU
    A(i+1:n,i)=A(i+1:n,i)/A(i,i);
    A(i+1:n,i+1:n)=A(i+1:n,i+1:n)-A(i+1:n,i)*A(i,i+1:n);
end