function C = matmat(A,B,mode)

% function C = matmat(A,B,mode)
% calcola il prodotto matrice matrice A x B
% C e'la matrice risultato
% mode e' un parametro che sceglie l'ottimizzazione
% mode='c' ottimizzazione per mem. per colonne
% mode='r' ottimizzazione per mem. per righe

[m,n]=size(A);
[n1,p]=size(B);
if (n~=n1)
    error('Numero di colonne di A diverso da numero di righe di B');
end
C=zeros(m,p);

if (mode=='r')
    % algoritmo ottimizzato per mem. per righe
    for i=1:m,
        for j=1:n,
            for k=1:p,
                C(i,k)=C(i,k)+A(i,j)*B(j,k);
            end
        end
    end
    return
        
else
    % algoritmo ottimizzato per mem. per colonne
    for k=1:p,
        for j=1:n,
            for i=1:m,
                C(i,k)=C(i,k)+A(i,j)*B(j,k);
            end
        end
    end
    return
    
end