function [x,n] = newtonF(fun,dfun,x1,y1,x2,y2,tolx,maxiter,pun)

%function [x,n] = newtonF(fun,dfun,x1,y1,x2,y2,tolx,maxiter,pun)
%
% frattali di Newton: 
%
% fun funzione
% dfun derivata
% x1,y1,x2,y2 rettangolo complesso dei punti iniziali
% tolx tolleranza
% maxiter
% pun punti per il grafico (radice)
%
% ci vuole un quarto d'ora ma vale la pena, altrimenti diminuisci pun!
%ESEMPIO: newtonF('x^3-1','3*x^2',-8,-8,8,8,eps,100,10)
%newtonF('x^4-1','4*x^3',-1,-1,1,1,eps,100,10)

f=inline(fun);
df=inline(dfun);

puntix=pun;
puntiy=pun;

map=zeros(puntix,puntiy);
stepx= (x2-x1)/puntix;
stepy= (y2-y1)/puntiy;
indx=0;

for a=x1:stepx:x2,
indy=0;
indx=indx+1;

for b=y1:stepy:y2,
 indy=indy+1;
 
 x=a+i*b;
 n=0;
 fx=f(x);
 dfx=df(x);
 toly=abs(tolx*dfx);

 while n<maxiter && abs(fx)>toly
  x=x-fx/dfx;
  fx=f(x);
  dfx=df(x);
  toly=abs(tolx*dfx);
  n=n+1;
 end

 %map(indx,indy)=n;
 %il codice di seguito funziona solo per x^3..
 if imag(x) > 0.5
  map(indx,indy)=1+n;
 end
 if imag(x) < -0.5
  map(indx,indy)=100+n;

 end
 if real(x) > 0.5
  map(indx,indy)=300+n;

 end
% plot(a,b,'r');
end
end
a=x1:stepx:x2;
b=y1:stepy:y2;
contourf(a,b,map)
%scatter(a,b,3,map)



