function [x] = qr_fact_sys (A, b)
%[x] qr_fact_sys = (A, b)

[m,n]=size(A);
if (m==n)
    warning('Matrice quadrata, metodo non efficiente')
end

for i=1:n
    alfa=norm(A(i:m,i));
    %norma della colonna i-esima
    if (alfa==0)
        error('La matrice non ha rango massimo')
    end
    v_1=A(i,i);
    if v_1>=0
        %calcolo del primo elemento del vettore di
        %Householder
        v_1=v_1+alfa;
        A(i,i)=-alfa;
        segno=1;
    else
        v_1=v_1-alfa;
        A(i,i)=alfa;
        segno=-1;
    end
    A(i+1:m,i)=A(i+1:m,i)/v_1;
    %normalizzazione vettore di Householder
    beta=segno*v_1/alfa;
    %aggiornamento di A al passo i-esimo
    A(i:m,i+1:n)=A(i:m,i+1:n)-(beta*[1;A(i+1:m,i)])*([1;A(i+1:m,i)]'*A(i:m,i+1:n));
    b(i:m)=b(i:m)-((beta*[1;A(i+1:m,i)])*([1;A(i+1:m,i)]'*b(i:m)));
end

x=utri_sys(A(1:n,1:n),b(1:n));
return; 
