function prob = DFP (prob, unidimAlg)
if (nargin==1)
    unidimAlg='armijo';
end

% Davidon-Fletcher-Powel

tol=getTol(prob);
tol2=tol^2;
maxiter=getMaxiter(prob);

x=getStart(prob); %Prendo il punto iniziale

gx=getGrad(prob,x);% calcolo il gradiente nel punto

dim=length(x);
d=-gx;

n=0;
while n<maxiter && gx'*gx>tol2
    res=eval(strcat(unidimAlg,'(prob,x,d,gx)'));
    p=res{1}-x;
    x=res{1};
    nextPoint(prob,x);
    oldg=gx;
    gx=getGrad(prob,x);
    q=gx-oldg;
    if mod(n,3)==0
        H=eye(dim);
    else
        Hq=H*q;
        if (Hq==0)
            return;
        end
        H=H+p*p'/(p'*q)-Hq*Hq'/(q'*Hq);
    end
    d=-H*gx;
    n=n+1;
end