function p = LevMarq(p, unidimAlg)
if (nargin==1)
    unidimAlg='armijo';
end

tol=getTol(p);
tol2=tol^2;
maxiter=getMaxiter(p);

x=getStart(p); %Prendo il punto iniziale
gx=getGrad(p,x);% calcolo il gradiente nel punto
hx=getHess(p,x);% calcolo l'hessiana nel punto

%eseguo una prima volta la fattorizzazione LDL^T
d=-ldlt_fact_sys(hx,gx);

n=0;
e=0;

while n < maxiter && gx'*gx > tol2
    adder=norm(hx,inf)/length(hx);
    e=max(0,e-adder);
    %controllo che la fattorizzazione sia andata a buon fine
    %altrimenti aggiorno la hx e fattorizzo nuovamente
    while(all(d==0))
        e=e+adder;
        d=-ldlt_fact_sys(e*eye(2)+hx,gx);
    end
    res=eval(strcat(unidimAlg,'(p,x,d,gx)'));
    
    x=res{1};
    fx1=res{2};
    nextPoint(p,x);
    n=n+1;
    gx=getGrad(p,x); %riaggiorno il gradiente
    hx=getHess(p,x);
    d=-ldlt_fact_sys(hx,gx);
end