function p = TrustRegDogleg(p, arg2)

%trust region con matrice di Levemberg-Marquardt e
%metodo dogleg

tol=getTol(p);
tol2=tol^2;
maxiter=getMaxiter(p);
debug= false;

maxDelta=.5;
delta=.2;
eta=1/5;

x=getStart(p);  % Prendo il punto iniziale
gx=getGrad(p,x);% Calcolo il gradiente nel punto
hx=getHess(p,x);% Calcolo l'hessiana nel punto

pb=-ldlt_fact_sys(hx,gx);

n=0;
e=0;

while n<maxiter && gx'*gx>tol2
    adder=norm(hx,inf)/length(hx);
    e=max(0,e-adder); 
    
    Bk=hx;
    
    fx=getValue(p,x);
    while(all(pb==0))
        e=e+adder;
        Bk=e*eye(2)+hx;
        pb=-ldlt_fact_sys(Bk,gx);
    end
    
    %--- metodo Dogleg
    
    pu=-(gx'*gx/(gx'*Bk*gx))*gx;
    
    %--- determino il punto di minimo sulla
    %--- spezzata
    if norm(pb)<= delta
        pk=pb;
        if debug
            graphix(n+1,3)=1;
        end
    elseif norm(pu) >= delta
        if debug
            graphix(n+1,3)=2;
        end
        pk=-gx*delta/norm(gx);
    else
        if debug
            graphix(n+1,3)=3;
        end
        a=(pb-pu)'*(pb-pu);
        b=2*(pb-pu)'*pu;
        c=pu'*pu-delta^2;
        d=sqrt(b^2-4*a*c);
        tau=(-b+d)/(2*a);    
        if ~(tau >=0 && tau <= 1)
            tau=(-b-d)/(2*a);
        end
        pk=pu+tau*pb;
    end
    fxkpk=getValue(p,x+pk);
    
    %--- aggiorno la trust region
    mkpk=fx+gx'*pk+pk'*Bk*pk/2;
    rhok=(fx-fxkpk)/(fx-mkpk);
    if debug
        graphix(n+1,1) = delta;
        graphix(n+1,2)= rhok;
    end
    if rhok < 1/4
        delta=norm(pk)/4;
    elseif rhok > 3/4 && abs(norm(pk)-delta)<eps*10
        boh=norm(pk)-delta;
        delta=min(2*delta,maxDelta);
    end
    
    %--- scelgo se accettare o meno il nuovo passo
    if rhok > eta
        x=x+pk;
        fx=fxkpk;
        nextPoint(p,x);
        gx=getGrad(p,x); %riaggiorno il gradiente
        hx=getHess(p,x);
        pb=-ldlt_fact_sys(hx,gx);
    else
        %--- se non cambio punto, mi ricordo la matrice
        %--- calcolata
        hx=Bk;
        pb=0;
    end
    n=n+1;
end

if debug
    figure
    plot(graphix)
    legend('delta','rho','tipo')
    graphix
end

