function res = fibonacci(p,x0,d,gx)
%function res = fibonacci(p,x,d,gx)
%
% Funzione per la minimizzazione line search con il metodo di Fibonacci
%
% res e' un cell array della forma {a,b} dove a e' il punto
% trovato, e b=f(a)


maxiter=getMaxiter(p);
N=maxiter;
tol=getTol(p);
tol2=tol^2;

g0=gx'*d;
if(g0==0)
    f0=getValue(p,x0);
    res={x0,f0};
    return;
end;

% inizializzazione del TPP
step=abs(atan(g0)/g0);
[a,ab,b,fa,fab,fb]=initTPP(p,x0,d,step);

f1=1;
f2=1;
for i=2:N
    f0=f1;
    f1=f2;
    f2=f0+f1;
end


l1=(b-a)*f0/f2;
x(1)=a+l1;
x(2)=b-l1;
f(1)=getValue(p,x0+x(1)*d);
f(2)=getValue(p,x0+x(2)*d);
for i=2:N-1
    if (b-a)<tol
        break;
    end
    if (f(1)>f(2))
        a=x(1);
        x(1)=a+b-x(2);
        f(1)=getValue(p,x0+x(1)*d);
    else
        b=x(2);
        x(2)=a+b-x(1);
        f(2)=getValue(p,x0+x(2)*d);
    end
    if (x(1)>x(2))
        x=x([2,1]);
        f=f([2,1]);
    end
end
x=x0+((x(1)+x(2))/2.0)*d;
fx=getValue(p,x);
res={x,fx};

return;
