function res = newton(p,x0,d,gx)
%function res = newton(p,x0,d,gx)
%
% Funzione per la minimizzazione line search con il metodo di Newton,
%
% res e' un cell array della forma {a,b} dove a e' il punto
% trovato, e b=f(a)

maxiter=getMaxiter(p);
tol=getTol(p);
tol2=tol^2;

gd=gx'*d;
if(gd==0)
    f0=getValue(p,x0);
    res={x0,f0};
    return;
end;

xk=x0;
alfa=0;
n=0;

while n < maxiter && (gx'*gx > tol2)      
      Hk=getHess(p,xk);
      gamma=d'*Hk*d;
      if gamma==0
          break;
      end
      delta=gd/gamma;
      alfa=alfa-delta;
      xk=x0+alfa*d;
      gk=getGrad(p,xk);
      gd=gk'*d;
      n=n+1;
end

fx=getValue(p,xk);
res={xk,fx};
return;



