function res = secant(p,x,d,gx)
%function res = secant(p,x,d,gx)
%
% Funzione per la minimizzazione line search con il metodo delle secanti
%
% res e' un cell array della forma {a,b} dove a e' il punto
% trovato, e b=f(a)


maxiter=getMaxiter(p);
tol=getTol(p);
tol2=tol^2;

gk1=gx'*d;

if(gk1==0)
    fx1=getValue(p,x);
    res={x, fx1};
    return;
end;

alfa2=abs(atan(gk1)/gk1);
if(alfa2==0)
	fxk2=getValue(p,x);
	res={x,fxk2};     
	return;
end
xk2=x+alfa2*d;
gx2=getGrad(p, xk2);    
if (maxiter==1 || gx2'*gx2<=tol2)
    fxk2=getValue(p,xk2);
    res={xk2,fxk2};
    return;
end
gk2=gx2'*d;
g1k2=(gk2-gk1)/alfa2;
alfa1=alfa2;
alfa2=alfa1-gk2/g1k2;    
xk2=x+alfa2*d;
gx2=getGrad(p,xk2);
n=2;
deltaAlfa=alfa2-alfa1;
while n<maxiter && gx2'*gx2>tol2 && deltaAlfa>tol
    gk1=gk2;
    gk2=gx2'*d;
    deltaAlfa=alfa2-alfa1;
    if(deltaAlfa==0)
        fxk2=getValue(p,xk2);
        res={xk2,fxk2};  
        return;
    end
    g1k2=(gk2-gk1)/deltaAlfa;
    alfa1=alfa2;
    alfa2=alfa1-gk2/g1k2;    
    xk2=x+alfa2*d;
    gx2=getGrad(p,xk2);
    n=n+1;
end

fxk2=getValue(p,xk2);
res={xk2,fxk2};

return;

